OGRE: Ogre::GpuProgramUsage Class Reference - OGRE Documentation

# Ogre::GpuProgramUsage Class Reference

This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit. More...

`#include <OgreGpuProgramUsage.h>`

Inheritance diagram for Ogre::GpuProgramUsage:

[legend]

List of all members.

## Public Member Functions
| GpuProgramUsage (GpuProgramType gptype)
| Default constructor.
| GpuProgramUsage (const GpuProgramUsage &rhs)
| Copy constructor.
GpuProgramType | getType (void) const
| Gets the type of program we're trying to link to.
void | setProgramName (const String &name, bool resetParams=true)
| Sets the name of the program to use.
void | setProgram (GpuProgramPtr &prog)
| Sets the program to use.
const GpuProgramPtr & | getProgram () const
| Gets the program being used.
const String & | getProgramName (void) const
| Gets the program being used.
void | setParameters (GpuProgramParametersSharedPtr params)
| Sets the program parameters that should be used; because parameters can be shared between multiple usages for efficiency, this method is here for you to register externally created parameter objects.
GpuProgramParametersSharedPtr | getParameters (void)
| Gets the parameters being used here.
void | _load (void)
| Load this usage (and ensure program is loaded).
void | _unload (void)
| Unload this usage.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Attributes
GpuProgramType | mType
GpuProgramPtr | mProgram
GpuProgramParametersSharedPtr | mParameters
| program parameters

## Detailed Description

This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit.

Remarks:
  Using a vertex or fragment program can get fairly complex; besides the fairly rudimentary process of binding a program to the GPU for rendering, managing usage has few complications, such as:
  - Programs can be high level (e.g. Cg, RenderMonkey) or low level (assembler). Using either should be relatively seamless, although high-level programs give you the advantage of being able to use named parameters, instead of just indexed registers
  - Programs and parameters can be shared between multiple usages, in order to save memory
  - When you define a user of a program, such as a material, you often want to be able to set up the definition but not load / compile / assemble the program at that stage, because it is not needed just yet. The program should be loaded when it is first needed, or earlier if specifically requested. The program may not be defined at this time, you may want to have scripts that can set up the definitions independent of the order in which those scripts are loaded.
  This class packages up those details so you don't have to worry about them. For example, this class lets you define a high-level program and set up the parameters for it, without having loaded the program (which you normally could not do). When the program is loaded and compiled, this class will then validate the parameters you supplied earlier and turn them into runtime parameters.

  Just incase it wasn't clear from the above, this class provides linkage to both GpuProgram and HighLevelGpuProgram, despite its name.

Definition at line 66 of file OgreGpuProgramUsage.h.

## Constructor & Destructor Documentation

Ogre::GpuProgramUsage::GpuProgramUsage | ( | GpuProgramType | gptype | ) |

Default constructor.

Parameters:

  | gptype | The type of program to link to

Ogre::GpuProgramUsage::GpuProgramUsage | ( | const GpuProgramUsage & | rhs | ) |

Copy constructor.

## Member Function Documentation

GpuProgramType Ogre::GpuProgramUsage::getType | ( | void |  | ) | const

Gets the type of program we're trying to link to.

Definition at line 87 of file OgreGpuProgramUsage.h.

void Ogre::GpuProgramUsage::setProgramName | ( | const String & | name,
|  | bool | resetParams = `true` |
| ) |  |  |

Sets the name of the program to use.

Parameters:

  | name | The name of the program to use
  | resetParams | If true, this will create a fresh set of parameters from the new program being linked, so if you had previously set parameters you will have to set them again. If you set this to false, you must be absolutely sure that the parameters match perfectly, and in the case of named parameters refers to the indexes underlying them, not just the names.

void Ogre::GpuProgramUsage::setProgram | ( | GpuProgramPtr & | prog | ) |

Sets the program to use.

Remarks:
  Note that this will create a fresh set of parameters from the new program being linked, so if you had previously set parameters you will have to set them again.

const GpuProgramPtr& Ogre::GpuProgramUsage::getProgram | ( |  | ) | const

Gets the program being used.

Definition at line 108 of file OgreGpuProgramUsage.h.

const String& Ogre::GpuProgramUsage::getProgramName | ( | void |  | ) | const

Gets the program being used.

Definition at line 110 of file OgreGpuProgramUsage.h.

void Ogre::GpuProgramUsage::setParameters | ( | GpuProgramParametersSharedPtr | params | ) |

Sets the program parameters that should be used; because parameters can be shared between multiple usages for efficiency, this method is here for you to register externally created parameter objects.

Otherwise, the parameters will be created for you when a program is linked.

GpuProgramParametersSharedPtr Ogre::GpuProgramUsage::getParameters | ( | void |  | ) |

Gets the parameters being used here.

void Ogre::GpuProgramUsage::_load | ( | void |  | ) |

Load this usage (and ensure program is loaded).

void Ogre::GpuProgramUsage::_unload | ( | void |  | ) |

Unload this usage.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

GpuProgramType Ogre::GpuProgramUsage::mType`[protected]`

Definition at line 69 of file OgreGpuProgramUsage.h.

GpuProgramPtr Ogre::GpuProgramUsage::mProgram`[protected]`

Definition at line 71 of file OgreGpuProgramUsage.h.

GpuProgramParametersSharedPtr Ogre::GpuProgramUsage::mParameters`[protected]`

program parameters

Definition at line 74 of file OgreGpuProgramUsage.h.

The documentation for this class was generated from the following file:

- OgreGpuProgramUsage.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:33:26 2009